stages:
  - test
  - deploy

test:
  stage: test
  image: python:3.11
  variables:
    POSTGRES_DB: ${POSTGRES_DB_NAME}
    POSTGRES_USER: ${POSTGRES_DB_USER}
    POSTGRES_HOST: ${POSTGRES_DB_USER}
    POSTGRES_PASSWORD: ${POSTGRES_DB_PASS}
  services:
    - postgres:16-alpine
  script:
    - pip install --upgrade pip
    - python3 -m venv venv
    - source venv/bin/activate
    - pip install -r requirements.txt
    - cd app
    - python3 manage.py test

deploy:latest:
  stage: deploy
  image: docker:latest
  services:
    - docker:dind
  script:
    - docker login -u $CI_REGISTRY_USER -p $CI_REGISTRY_PASSWORD $CI_REGISTRY
    - docker build -t $CI_CONTAINER_NAME:latest .
    - docker push $CI_CONTAINER_NAME:latest
  rules:
    - if: '$CI_COMMIT_BRANCH == "main"'
      when: manual

deploy:version:
  stage: deploy
  image: docker:latest
  services:
    - docker:dind
  script:
    - docker login -u $CI_REGISTRY_USER -p $CI_REGISTRY_PASSWORD $CI_REGISTRY
    - docker build -t $CI_CONTAINER_NAME:$CI_COMMIT_TAG .
    - docker push $CI_CONTAINER_NAME:$CI_COMMIT_TAG
  rules:
    - if: '$CI_COMMIT_TAG'
      when: manual
